import json
from base64 import b64decode, b64encode

DATA_DIR = '/var/lib/spoc'
AUTOSTART_FILE = '/var/lib/spoc/autostart'
LOCK_FILE = '/run/lock/spoc.lock'

REGISTRY_HOST = None
REGISTRY_AUTH = None
REGISTRY_AUTH_FILE = '/var/lib/spoc/auth.json'
REPO_FILE_URL = None

def read_auth():
    global REGISTRY_HOST, REGISTRY_AUTH, REPO_FILE_URL   # pylint: disable=global-statement

    try:
        with open(REGISTRY_AUTH_FILE, encoding='utf-8') as f:
            data = json.load(f)
        REGISTRY_HOST = next(iter(data['auths'].keys()))
        auth = b64decode(data['auths'][REGISTRY_HOST]['auth'].encode()).decode()
        REGISTRY_AUTH = tuple(auth.split(':', 1))
    except FileNotFoundError:
        REGISTRY_HOST = 'localhost'
        REGISTRY_AUTH = None
    REPO_FILE_URL = f'https://{REGISTRY_HOST}/repository.json'

def write_auth(host, username, password):
    global REGISTRY_HOST, REGISTRY_AUTH, REPO_FILE_URL   # pylint: disable=global-statement

    b64auth = b64encode(f'{username}:{password}'.encode()).decode()
    data = json.dumps({'auths': {host: {'auth': b64auth}}})
    with open(REGISTRY_AUTH_FILE, 'w', encoding='utf-8') as f:
        f.write(data)
    REGISTRY_HOST = host
    REGISTRY_AUTH = (username, password)
    REPO_FILE_URL = f'https://{REGISTRY_HOST}/repository.json'

read_auth()
